var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/github/src/index.ts
var src_exports = {};
__export(src_exports, {
  install: () => install,
  name: () => name,
  using: () => using
});
module.exports = __toCommonJS(src_exports);
var import_plugin_database = require("@zhinjs/plugin-database");

// packages/github/src/webhook.ts
var import_webhooks = require("@octokit/webhooks");
var import_koa_connect = __toESM(require("koa-connect"));
var import_plugin_http = require("@zhinjs/plugin-http");

// packages/github/src/markdown.ts
var import_icqq_cq_enable = require("icqq-cq-enable");
var import_icqq = require("icqq");
var import_marked = require("marked");
function renderToken(token) {
  if (token.type === "code") {
    return token.text + "\n";
  } else if (token.type === "paragraph") {
    return render(token.tokens);
  } else if (token.type === "image") {
    return (0, import_icqq_cq_enable.toCqcode)({ message: [import_icqq.segment.image(token.href)] });
  } else if (token.type === "blockquote") {
    return token.text;
  }
  return token.raw;
}
__name(renderToken, "renderToken");
function render(tokens) {
  return tokens.map(renderToken).join("");
}
__name(render, "render");
function transform(source) {
  if (!source)
    return "";
  source = source.replace(/^<!--(.*)-->$/gm, "");
  return render(import_marked.marked.lexer(source)).trim().replace(/\n\s*\n/g, "\n");
}
__name(transform, "transform");

// packages/github/src/webhook.ts
function subscribe(bot, config) {
  const webhook = new import_webhooks.Webhooks({
    secret: config.secret
  });
  addListeners(webhook, bot, config.group_id);
  bot.koa.use((0, import_koa_connect.default)((0, import_webhooks.createNodeMiddleware)(webhook, { path: config.hook_url })));
}
__name(subscribe, "subscribe");
function addListeners(webhook, bot, group_id) {
  const createFactory = /* @__PURE__ */ __name((callback) => (event, handler) => {
    webhook.on(event, ({ payload }) => Reflect.apply(callback, null, [event, payload, handler]));
  }, "createFactory");
  webhook.on("fork", ({ payload: { repository, sender, forkee } }) => {
    const { full_name, forks_count } = repository;
    return bot.sendGroupMsg(group_id, [`${sender.login} forked ${full_name} to ${forkee.full_name} (total ${forks_count} forks)`]);
  });
  const onIssue = createFactory((event, payload, handler) => {
    const { user, url, html_url, comments_url } = payload.issue;
    if (user.type === "Bot")
      return;
    const [message, replies] = handler(payload);
    return [message, {
      close: [url, comments_url],
      link: [html_url],
      react: [url + `/reactions`],
      reply: [comments_url],
      ...replies
    }];
  });
  onIssue("issues.opened", ({ repository, issue, sender }) => {
    const { full_name } = repository;
    const { title, body, number } = issue;
    return bot.sendGroupMsg(group_id, [[
      `${sender.login} opened an issue ${full_name}#${number}`,
      `Title: ${title}`,
      transform(body)
    ].join("\n")]);
  });
  onIssue("issues.closed", ({ repository, issue, sender }) => {
    const { full_name } = repository;
    const { title, number } = issue;
    return bot.sendGroupMsg(group_id, [`${sender.login} closed issue ${full_name}#${number}
${title}`]);
  });
  webhook.on("milestone.created", ({ payload: { repository, milestone, sender } }) => {
    const { full_name } = repository;
    const { title, description } = milestone;
    return bot.sendGroupMsg(group_id, [`${sender.login} created milestone ${title} for ${full_name}
${description}`]);
  });
  webhook.on("pull_request_review.submitted", ({ payload: { repository, review, pull_request } }) => {
    if (!review.body)
      return;
    const { full_name } = repository;
    const { number } = pull_request;
    const { user, body } = review;
    if (user.type === "Bot")
      return;
    return bot.sendGroupMsg(group_id, [[
      `${user.login} reviewed pull request ${full_name}#${number}`,
      transform(body)
    ].join("\n")]);
  });
  const onPullRequest = createFactory((event, payload, handler) => {
    const { user, url, html_url, issue_url, comments_url } = payload.pull_request;
    if (user.type === "Bot")
      return;
    const [message, replies] = handler(payload);
    return [message, {
      base: [url],
      close: [issue_url, comments_url],
      link: [html_url],
      merge: [url + "/merge"],
      rebase: [url + "/merge"],
      squash: [url + "/merge"],
      react: [issue_url + `/reactions`],
      reply: [comments_url],
      ...replies
    }];
  });
  onPullRequest("pull_request.closed", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { title, number, merged } = pull_request;
    const type = merged ? "merged" : "closed";
    return bot.sendGroupMsg(group_id, [`${sender.login} ${type} pull request ${full_name}#${number}
${title}`]);
  });
  onPullRequest("pull_request.reopened", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { title, number } = pull_request;
    return bot.sendGroupMsg(group_id, [`${sender.login} reopened pull request ${full_name}#${number}
${title}`]);
  });
  onPullRequest("pull_request.opened", ({ payload: { repository, pull_request, sender } }) => {
    const { full_name, owner } = repository;
    const { title, base, head, body, number, draft } = pull_request;
    const prefix = new RegExp(`^${owner.login}:`);
    const baseLabel = base.label.replace(prefix, "");
    const headLabel = head.label.replace(prefix, "");
    return bot.sendGroupMsg(group_id, [[
      `${sender.login} ${draft ? "drafted" : "opened"} a pull request ${full_name}#${number} (${baseLabel} ← ${headLabel})`,
      `Title: ${title}`,
      transform(body)
    ].join("\n")]);
  });
  onPullRequest("pull_request.review_requested", ({ payload }) => {
    const { repository, pull_request, sender } = payload;
    const { full_name } = repository;
    const { number } = pull_request;
    return bot.sendGroupMsg(group_id, ["requested_reviewer" in payload ? `${sender.login} requested a review from ${payload.requested_reviewer.login} on ${full_name}#${number}` : `${sender.login} requested a review from team ${payload.requested_team.name} on ${full_name}#${number}`]);
  });
  onPullRequest("pull_request.converted_to_draft", ({ payload: { repository, pull_request, sender } }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    return bot.sendGroupMsg(group_id, [`${sender.login} marked ${full_name}#${number} as draft`]);
  });
  onPullRequest("pull_request.ready_for_review", ({ payload: { repository, pull_request, sender } }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    return bot.sendGroupMsg(group_id, [`${sender.login} marked ${full_name}#${number} as ready for review`]);
  });
  webhook.on("push", ({ payload: { compare, pusher, sender, commits, repository, ref, before, after } }) => {
    const { full_name } = repository;
    if (sender.type === "Bot")
      return;
    if (/^0+$/.test(before) || /^0+$/.test(after))
      return;
    return bot.sendGroupMsg(group_id, [[
      `${pusher.name} pushed to ${full_name}:${ref.replace(/^refs\/heads\//, "")}`,
      ...commits.map((c) => `[${c.id.slice(0, 6)}] ${transform(c.message)}`)
    ].join("\n")]);
  });
  webhook.on("star.created", ({ payload: { repository, sender } }) => {
    const { full_name, stargazers_count } = repository;
    return bot.sendGroupMsg(group_id, [`${sender.login} starred ${full_name} (total ${stargazers_count} stargazers)`]);
  });
}
__name(addListeners, "addListeners");

// packages/github/src/models/github.ts
var import_sequelize = require("sequelize");
var Github = {
  group_id: import_sequelize.DataTypes.BIGINT,
  repo_name: import_sequelize.DataTypes.STRING,
  secret: import_sequelize.DataTypes.STRING,
  hook_url: import_sequelize.DataTypes.STRING
};

// packages/github/src/index.ts
var name = "github";
var using = ["database", "http"];
function install(bot) {
  bot.database.define("github", Github);
  bot.command("repo.unwatch <repo_name:string>", "group").desc("移除仓库监听").check(({ event }) => !bot.isMaster(event.user_id)).action(async (_, repo_name) => {
    await bot.database.model("github").destroy({
      where: {
        repo_name
      }
    });
    return "已移除监听" + repo_name;
  });
  bot.command("repo.watch <repo_name:string>", "group").desc("添加仓库监听").check(({ event }) => !bot.isMaster(event.user_id)).option("secret", "-c <secret:string> 鉴权秘钥").option("hook_path", "-h <hook_path:string> webhook代理地址").action(async ({ event, options }, repo_name) => {
    if (!event["group_id"])
      return;
    const config = {
      group_id: event["group_id"],
      secret: options.secret,
      repo_name,
      hook_url: options.hook_path || "/webhook/" + repo_name
    };
    subscribe(bot, config);
    await bot.database.model("github").create({ ...config });
  });
  bot.on("ready", async () => {
    const webhooks = await bot.database.model("github").findAll();
    for (const webhook of webhooks) {
      console.log(webhook.toJSON());
      subscribe(bot, webhook.toJSON());
    }
  });
}
__name(install, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  install,
  name,
  using
});
//# sourceMappingURL=index.js.map
